// Generated by LiveScript 1.4.0
var removeValue, ClientRegistry;
removeValue = require('remove-value');
ClientRegistry = (function(){
  ClientRegistry.displayName = 'ClientRegistry';
  var prototype = ClientRegistry.prototype, constructor = ClientRegistry;
  function ClientRegistry(){
    this._clients = {};
    this._subscribers = {};
  }
  prototype.client = function(name){
    return this._clients[name];
  };
  prototype.clients = function(){
    return this._clientData(Object.keys(this._clients));
  };
  prototype.register = function(service){
    var i$, ref$, len$, command, ref1$, results$ = [];
    this.removeService(service.name);
    this._clients[service.name] = service;
    for (i$ = 0, len$ = (ref$ = service.receives).length; i$ < len$; ++i$) {
      command = ref$[i$];
      results$.push(((ref1$ = this._subscribers)[command] || (ref1$[command] = [])).push(service.name));
    }
    return results$;
  };
  prototype.removeService = function(serviceName){
    var service, i$, ref$, len$, command, ref1$;
    if (!(service = this.client(serviceName))) {
      return;
    }
    for (i$ = 0, len$ = (ref$ = service.receives).length; i$ < len$; ++i$) {
      command = ref$[i$];
      removeValue(this._subscribers[command], serviceName);
    }
    return ref1$ = (ref$ = this._clients)[serviceName], delete ref$[serviceName], ref1$;
  };
  prototype.subscriberNamesTo = function(commandName){
    var ref$;
    return (ref$ = this._subscribers)[commandName] || (ref$[commandName] = []);
  };
  prototype.subscribersTo = function(commandName){
    return this._clientData(this.subscriberNamesTo(commandName));
  };
  prototype._clientData = function(clientNames){
    var i$, len$, name, results$ = [];
    for (i$ = 0, len$ = clientNames.length; i$ < len$; ++i$) {
      name = clientNames[i$];
      results$.push(this.client(name));
    }
    return results$;
  };
  return ClientRegistry;
}());
module.exports = ClientRegistry;