// Generated by LiveScript 1.4.0
var bodyParser, EventEmitter, express, debug, HttpListener;
bodyParser = require('body-parser');
EventEmitter = require('events').EventEmitter;
express = require('express');
debug = require('debug')('exorelay:http-listener');
HttpListener = (function(superclass){
  var prototype = extend$((import$(HttpListener, superclass).displayName = 'HttpListener', HttpListener), superclass).prototype, constructor = HttpListener;
  function HttpListener(){
    var x$;
    this._statusController = bind$(this, '_statusController', prototype);
    this._sendController = bind$(this, '_sendController', prototype);
    this._registerServiceController = bind$(this, '_registerServiceController', prototype);
    x$ = this.app = express();
    x$.use(bodyParser.json());
    x$.get('/status.json', this._statusController);
    x$.post('/register-service', this._registerServiceController);
    x$.post('/send/:command', this._sendController);
    this.port = null;
  }
  prototype.close = function(){
    switch (false) {
    case !!this.server:
      return;
    }
    debug("no longer listening at port " + this.port);
    return this.server.close();
  };
  prototype.listen = function(port){
    var x$, this$ = this;
    this.port = +port;
    switch (false) {
    case !isNaN(this.port):
      this.emit('error', 'Non-numerical port provided to ExoRelay#listen');
    }
    x$ = this.server = this.app.listen(this.port);
    x$.on('error', function(err){
      if (err.code === 'EADDRINUSE') {
        err = "port " + err.port + " is already in use";
      }
      return this$.emit('error', err);
    });
    x$.on('listening', function(){
      return this$.emit('listening', this$.port);
    });
    return x$;
  };
  prototype._registerServiceController = function(req, res){
    var requestData, result;
    requestData = req.body.payload;
    debug("service '" + requestData.name + "' requesting to register");
    switch (result = this.listeners('register-service')[0](requestData)) {
    case 'success':
      return res.status(200).end();
    default:
      throw new Error("unknown error");
    }
  };
  prototype._sendController = function(req, res){
    var requestData, result;
    requestData = this._parseRequest(req);
    this._log(requestData);
    switch (result = this.listeners('send-command')[0](requestData)) {
    case 'success':
      return res.status(200).end();
    case 'missing request id':
      return res.status(400).end('missing request id');
    case 'unknown command':
      return res.status(404).end("unknown command: '" + requestData.command + "'");
    default:
      throw new Error("unknown result code: '" + this.result + "'");
    }
  };
  prototype._statusController = function(req, res){
    return this.listeners('get-config')[0](function(config){
      return res.send(JSON.stringify(config));
    });
  };
  prototype._log = function(arg$){
    var name, requestId, responseTo;
    name = arg$.name, requestId = arg$.requestId, responseTo = arg$.responseTo;
    switch (false) {
    case !responseTo:
      return debug("received command '" + name + "' with id '" + requestId + "' in response to '" + responseTo + "'");
    default:
      return debug("received command '" + name + "' with id '" + requestId + "'");
    }
  };
  prototype._parseRequest = function(req){
    var name, payload, responseTo, requestId;
    name = req.params.command;
    payload = req.body.payload;
    responseTo = req.body.responseTo;
    requestId = req.body.requestId;
    return {
      name: name,
      responseTo: responseTo,
      payload: payload,
      requestId: requestId
    };
  };
  return HttpListener;
}(EventEmitter));
module.exports = HttpListener;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}